use crate::func::{context::*, *};
use crate::rcore::*;
use crate::rstd::counting::CountedInstance;

use super::*;

pub struct TestContextCounted;

impl<'a> FunctorContext<'a> for TestContextCounted {
    type T = CountedInstance;
}

impl<'a> FallibleCtx<'a> for TestContextCounted {
    type Fallible = instances::result::ResultFailOver<Self::T>;
}

impl<'a> Context<'a> for TestContextCounted {
    type D = NoDiagnostic;

    type LookupError = TestLookupError<'a>;

    fn hash(s: &[u8]) -> Hash {
        TestContextPlain::hash(s)
    }
}

struct CountedInject;

impl<'a> Inject<'a, TestContextCounted> for CountedInject {
    fn inject<A: 'a + Send>(
        &self,
        fa: Wrapped<'a, TestContextCounted, A>,
    ) -> Wrapped<'a, TestContextCounted, A> {
        fa.after_resolution()
    }
}

pub trait Delayable<'a>: Mentionable<'a, TestContextCounted> + Sized {
    fn delay(&self) -> ParseResultA<'a, Self> {
        Arc::new(CountedInject).inject_mentionable(self)
    }
}

impl<'a, A: Mentionable<'a, TestContextCounted>> Delayable<'a> for A {}
